## rmilter 1.6.0

=== CMakeLists.txt ===
############################# INITIAL SECTION #############################################

PROJECT(rmilter C)

SET(RMILTER_VERSION_MAJOR 1)
SET(RMILTER_VERSION_MINOR 6)
SET(RMILTER_VERSION_PATCH 0)

SET(RMILTER_VERSION         "${RMILTER_VERSION_MAJOR}.${RMILTER_VERSION_MINOR}.${RMILTER_VERSION_PATCH}")
SET(RMILTER_MASTER_SITE_URL "https://rspamd.com")

IF(NOT RMILTER_USER)
	SET(RMILTER_USER "nobody")
	SET(RMILTER_GROUP "nobody")
ENDIF()

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)

############################# OPTIONS SECTION #############################################

OPTION(DEBUG_MODE          "Enable debug output [default: ON]"                  ON)
OPTION(ENABLE_OPTIMIZATION "Enable optimization [default: OFF]"                 OFF)
OPTION(ENABLE_DKIM         "Enable dkim signatures [default: OFF]"              OFF)
OPTION(ENABLE_SPF          "Enable SPF checks [default: OFF]"                   OFF)

############################# INCLUDE SECTION #############################################

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCCompilerFlag)
INCLUDE(FindOpenSSL)
INCLUDE(FindThreads)

FIND_PACKAGE(BISON)
FIND_PACKAGE(FLEX)

MACRO(ProcessPackage var _name0)
    PKG_SEARCH_MODULE(${var} "${_name0}" ${ARGN})
    IF(${var}_FOUND)
        SET(WITH_${var} 1)
        SET(_XPREFIX "${var}")
        FOREACH(_arg ${${_XPREFIX}_INCLUDE_DIRS})
            INCLUDE_DIRECTORIES("${_arg}")
        ENDFOREACH(_arg ${${_XPREFIX}_INCLUDE_DIRS})
        FOREACH(_arg ${${_XPREFIX}_LIBRARY_DIRS})
            LINK_DIRECTORIES("${_arg}")
        ENDFOREACH(_arg ${${_XPREFIX}_LIBRARY_DIRS})
        # Handle other CFLAGS and LDFLAGS
        FOREACH(_arg ${${_XPREFIX}_CFLAGS_OTHER})
            SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${_arg}")
        ENDFOREACH(_arg ${${_XPREFIX}_CFLAGS_OTHER})
        FOREACH(_arg ${${_XPREFIX}_LDFLAGS_OTHER})
            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${_arg}")
        ENDFOREACH(_arg ${${_XPREFIX}_LDFLAGS_OTHER})
        LIST(APPEND RMILTER_REQUIRED_LIBRARIES "${${_XPREFIX}_LIBRARIES}")
    ENDIF(${var}_FOUND)
ENDMACRO(ProcessPackage name)

############################# OS SECTION #############################################

IF(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_BSD_SOURCE -DFREEBSD")
	MESSAGE(STATUS "Configuring for FreeBSD")
ENDIF(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_BSD_SOURCE -DDARWIN")
    SET(CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS "${CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS} -undefined dynamic_lookup")
MESSAGE(STATUS "Configuring for Darwin")

ENDIF()

IF(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -DLINUX")
    IF(BUILD_CPU_MODE STREQUAL "32")
    	SET(CMAKE_C_FLAGS  "-D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE ${CMAKE_C_FLAGS}")
    ENDIF(BUILD_CPU_MODE STREQUAL "32")
ENDIF()

IF(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
 	IF(NOT BUILD_CPU_MODE)
	 	SET (BUILD_CPU_MODE "32")
	ENDIF(NOT BUILD_CPU_MODE)
	
	IF("${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Xa -xregs=no%frameptr -xstrconst -xc99")
		SET(SUN_BUILD32 "-xtarget=generic")
		SET(SUN_BUILD64 "-xtarget=generic64")
		IF(ENABLE_OPTIMIZATION MATCHES "ON")
			SET(CMAKE_C_OPT_FLAGS "-fast -xdepend")
		ELSE(ENABLE_OPTIMIZATION MATCHES "ON")
			SET(CMAKE_C_OPT_FLAGS "-xO0")
		ENDIF(ENABLE_OPTIMIZATION MATCHES "ON")
	ELSE("${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
		set(SUN_BUILD32 "-m32")
		set(SUN_BUILD64 "-m64")		
	ENDIF("${CMAKE_C_COMPILER_ID}" MATCHES SunPro)

 	IF (BUILD_CPU_MODE STREQUAL "32")
       message (STATUS "Building 32-bit mode on Solaris")
       # If we are asked to build 32 bit mode
       	set(CMAKE_C_FLAGS  "${SUN_BUILD32} ${CMAKE_C_FLAGS}")
       	set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS} ${SUN_BUILD32}")
 	ELSE (BUILD_CPU_MODE STREQUAL "32")
       # solaris 64-bit mode
		message (STATUS "Building 64-bit mode on Solaris")
       	set(CMAKE_C_FLAGS  "${SUN_BUILD64} ${CMAKE_C_FLAGS}")
       	set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS} ${SUN_BUILD64}")
    ENDIF (BUILD_CPU_MODE STREQUAL "32")

 	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__EXTENSIONS__ -DSOLARIS -D_POSIX_SOURCE -D_POSIX_C_SOURCE=200112L")
    
	LIST(APPEND CMAKE_REQUIRED_LIBRARIES rt)
	LIST(APPEND CMAKE_REQUIRED_LIBRARIES dl)
	LIST(APPEND CMAKE_REQUIRED_LIBRARIES resolv)
 	LIST(APPEND CMAKE_REQUIRED_LIBRARIES nsl)
 	LIST(APPEND CMAKE_REQUIRED_LIBRARIES socket)
 	LIST(APPEND CMAKE_REQUIRED_LIBRARIES umem)
 	# Ugly hack, but FindOpenSSL on Solaris does not link with libcrypto
 	LIST(APPEND CMAKE_REQUIRED_LIBRARIES crypto)
  	SET(CMAKE_VERBOSE_MAKEFILE ON)
  	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
  	SET(CMAKE_INSTALL_RPATH "${PREFIX}/lib")	
ENDIF()

############################# CONFIGURE SECTION #############################################

INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include" 
					"${CMAKE_BINARY_DIR}/include"
					"${CMAKE_BINARY_DIR}/" 
					"${CMAKE_SOURCE_DIR}/compat"
					"${CMAKE_SOURCE_DIR}/uthash")

BISON_TARGET(CfgParser src/cfg_file.y ${CMAKE_CURRENT_BINARY_DIR}/cfg_yacc.c)
FLEX_TARGET(CfgScanner src/cfg_file.l  ${CMAKE_CURRENT_BINARY_DIR}/cfg_lex.c)
ADD_FLEX_BISON_DEPENDENCY(CfgScanner CfgParser)

#Check for openssl (required for dkim)
IF(OPENSSL_FOUND)
	INCLUDE_DIRECTORIES("${OPENSSL_INCLUDE_DIR}")
	LIST(APPEND RMILTER_REQUIRED_LIBRARIES "${OPENSSL_LIBRARIES}")
ELSE()
    MESSAGE(FATAL_ERROR "rmilter requires openssl for build")
ENDIF()

ProcessPackage(PCRE libpcre libpcre3 pcre pcre3)
IF(NOT PCRE_FOUND)
    FIND_LIBRARY(LIBPCRE_LIBRARY NAMES pcre PATH_SUFFIXES lib64 lib lib/libpcre lib64/lipcre
                      PATHS
                          ~/Library/Frameworks
                          /Library/Frameworks
                          /usr/local
                          /usr
                          /sw
                          /opt/local
                          /opt/csw
                          /opt
                     DOC "Path where the pcre library can be found")
    
    FIND_PATH(LIBPCRE_INCLUDE pcre.h PATH_SUFFIXES include include/pcre3 
                    PATHS   ~/Library/Frameworks
                          /Library/Frameworks
                          /usr/local
                          /usr
                          /sw
                          /opt/local
                          /opt/csw
                          /opt
                    DOC "Path where the pcre header files can be found")
    IF(NOT LIBPCRE_LIBRARY OR NOT LIBPCRE_INCLUDE)
    	MESSAGE(FATAL_ERROR "libpcre is required for building rmilter")
    ENDIF()
    LIST(APPEND RMILTER_REQUIRED_LIBRARIES "pcre")
    
    GET_FILENAME_COMPONENT(LIBPCRE_PATH "${LIBPCRE_LIBRARY}" PATH)
    INCLUDE_DIRECTORIES("${LIBPCRE_INCLUDE}")
    LINK_DIRECTORIES("${LIBPCRE_PATH}")
ENDIF(NOT PCRE_FOUND)

FIND_LIBRARY(LIBMILTER_LIBRARY NAMES milter PATH_SUFFIXES lib64 lib lib/libmilter lib64/libmilter
                  PATHS
                      ~/Library/Frameworks
                      /Library/Frameworks
                      /usr/local
                      /usr
                      /sw
                      /opt/local
                      /opt/csw
                      /opt
                 DOC "Path where the libmilter library can be found")

FIND_PATH(LIBMILTER_INCLUDE mfapi.h PATH_SUFFIXES include include/libmilter 
                PATHS   ~/Library/Frameworks
                      /Library/Frameworks
                      /usr/local
                      /usr
                      /sw
                      /opt/local
                      /opt/csw
                      /opt
                DOC "Path where the libmilter header files can be found")
IF(NOT LIBMILTER_LIBRARY OR NOT LIBMILTER_INCLUDE)
	MESSAGE(FATAL_ERROR "libmilter is required for building rmilter")
ENDIF()
LIST(APPEND RMILTER_REQUIRED_LIBRARIES "milter")

GET_FILENAME_COMPONENT(LIBMILTER_PATH "${LIBMILTER_LIBRARY}" PATH)
INCLUDE_DIRECTORIES("${LIBMILTER_INCLUDE}")
LINK_DIRECTORIES("${LIBMILTER_PATH}")

IF(ENABLE_DKIM MATCHES "ON")
    SET(WITH_DKIM 1)
    FIND_LIBRARY(LIBOPENDKIM_LIBRARY NAMES opendkim PATH_SUFFIXES lib64 lib lib/libopendkim lib64/libopendkim
                      PATHS
                          ~/Library/Frameworks
                          /Library/Frameworks
                          /usr/local
                          /usr
                          /sw
                          /opt/local
                          /opt/csw
                          /opt
                     DOC "Path where the opendkim library can be found")
    
    FIND_PATH(LIBOPENDKIM_INCLUDE dkim.h PATH_SUFFIXES include include/opendkim 
                    PATHS   ~/Library/Frameworks
                          /Library/Frameworks
                          /usr/local
                          /usr
                          /sw
                          /opt/local
                          /opt/csw
                          /opt
                    DOC "Path where the opendkim header files can be found")
    IF(NOT LIBOPENDKIM_LIBRARY OR NOT LIBOPENDKIM_INCLUDE)
    	MESSAGE(FATAL_ERROR "libmilter is required for building rmilter")
    ENDIF()
    GET_FILENAME_COMPONENT(LIBOPENDKIM_PATH "${LIBOPENDKIM_LIBRARY}" PATH)
    INCLUDE_DIRECTORIES("${LIBOPENDKIM_INCLUDE}")
    LINK_DIRECTORIES("${LIBOPENDKIM_PATH}")
    LIST(APPEND RMILTER_REQUIRED_LIBRARIES "opendkim")
ENDIF()

IF(ENABLE_SPF MATCHES "ON")
    SET(WITH_SPF 1)
    FIND_LIBRARY(LIBSPF2_LIBRARY NAMES spf2 PATH_SUFFIXES lib64 lib lib/libspf2 lib64/libspf2 lib/libspf lib64/libspf
                      PATHS
                          ~/Library/Frameworks
                          /Library/Frameworks
                          /usr/local
                          /usr
                          /sw
                          /opt/local
                          /opt/csw
                          /opt
                     DOC "Path where the libspf library can be found")
    
    FIND_PATH(LIBSPF2_INCLUDE spf.h PATH_SUFFIXES include include/spf include/spf2 
                    PATHS   ~/Library/Frameworks
                          /Library/Frameworks
                          /usr/local
                          /usr
                          /sw
                          /opt/local
                          /opt/csw
                          /opt
                    DOC "Path where the libspf header files can be found")
    IF(NOT LIBSPF2_LIBRARY OR NOT LIBSPF2_INCLUDE)
    	MESSAGE(FATAL_ERROR "libspf2 is required for building rmilter")
    ENDIF()
    GET_FILENAME_COMPONENT(LIBSPF2_PATH "${LIBSPF2_LIBRARY}" PATH)
    INCLUDE_DIRECTORIES("${LIBSPF2_INCLUDE}")
    LINK_DIRECTORIES("${LIBSPF2_PATH}")
    LIST(APPEND RMILTER_REQUIRED_LIBRARIES "spf2")
ENDIF()

# Process with warn flags
SET(CMAKE_C_WARN_FLAGS "")
CHECK_C_COMPILER_FLAG(-Wall SUPPORT_WALL)
CHECK_C_COMPILER_FLAG(-W SUPPORT_W)
CHECK_C_COMPILER_FLAG(-Wpointer-arith SUPPORT_WPOINTER)
CHECK_C_COMPILER_FLAG(-Wno-unused-parameter SUPPORT_WPARAM)
CHECK_C_COMPILER_FLAG(-Wno-unused-function SUPPORT_WFUNCTION)
CHECK_C_COMPILER_FLAG(-Wunused-variable SUPPORT_WUNUSED_VAR)
CHECK_C_COMPILER_FLAG(-Wpointer-sign SUPPORT_WPOINTER_SIGN)
CHECK_C_COMPILER_FLAG(-Wsign-compare SUPPORT_WSIGN_COMPARE)
CHECK_C_COMPILER_FLAG(-Wstrict-prototypes SUPPORT_WSTRICT_PROTOTYPES)
IF(NOT "${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
	CHECK_C_COMPILER_FLAG("-std=c99" SUPPORT_STD_FLAG)
ENDIF(NOT "${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
IF(SUPPORT_W)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -W")
ENDIF(SUPPORT_W)
IF(SUPPORT_WALL)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wall")
ENDIF(SUPPORT_WALL)
IF(SUPPORT_WPOINTER)

## rmilter 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 SET(RMILTER_VERSION_MAJOR 1)
 SET(RMILTER_VERSION_MINOR 6)
-SET(RMILTER_VERSION_PATCH 0)
+SET(RMILTER_VERSION_PATCH 1)
 
 SET(RMILTER_VERSION         "${RMILTER_VERSION_MAJOR}.${RMILTER_VERSION_MINOR}.${RMILTER_VERSION_PATCH}")
 SET(RMILTER_MASTER_SITE_URL "https://rspamd.com")

=== debian/changelog ===
rmilter (1.6.1) unstable; urgency=medium

  * Initial upload (Closes: #741161)

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 10 Mar 2014 00:55:10 +0100

=== debian/control ===
Source: rmilter
Section: mail
Priority: extra
Maintainer: Mikhail Gusarov <dottedmag@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), cmake, libpcre3-dev, libssl-dev (>= 1.0), libopendkim-dev, libmilter-dev, libspf2-dev, bison, flex
Standards-Version: 3.9.5
Homepage: https://github.com/vstakhov/rmilter
Vcs-Git: git://github.com/vstakhov/rmilter.git
Vcs-Browser: https://github.com/vstakhov/rmilter

Package: rmilter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: sendmail | postfix
Description: Another sendmail milter for different mail checks
 rmilter is a standalone application that provides the following features:
  SPF checks;
  greylisting using memcached storage;
  ratelimits using memcached storage;
  checking mail via rspamd/spamassassin;
  checking mail via clamav antivirus;
  regexp filters;
  DKIM signing;
  beanstalk operations for specific messages.
 .
 Rmilter uses sendmail milter interface and is compatible with Sendmail 
 and Postfix MTA  as well as with other MTA that supports milter interface.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_SPF=ON \
		-DENABLE_DKIM=ON \
		-DMANDIR=/usr/share/man

## rmilter 1.6.1build1

=== debian/changelog ===
rmilter (1.6.1build1) vivid; urgency=medium

  * No change rebuild for libopendkim10 transition

 -- Scott Kitterman <scott@kitterman.com>  Wed, 25 Feb 2015 16:52:07 -0500

## rmilter 1.6.3

=== CMakeLists.txt ===
############################# INITIAL SECTION #############################################

PROJECT(rmilter C)

SET(RMILTER_VERSION_MAJOR 1)
SET(RMILTER_VERSION_MINOR 6)
SET(RMILTER_VERSION_PATCH 3)

SET(RMILTER_VERSION         "${RMILTER_VERSION_MAJOR}.${RMILTER_VERSION_MINOR}.${RMILTER_VERSION_PATCH}")
SET(RMILTER_MASTER_SITE_URL "https://rspamd.com")

IF(NOT RMILTER_USER)
	SET(RMILTER_USER "nobody")
	SET(RMILTER_GROUP "nobody")
ENDIF()

IF(NOT SYSTEMDDIR)
	SET(SYSTEMDDIR ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
ENDIF(NOT SYSTEMDDIR)

IF(NOT MANDIR)
	SET(MANDIR "${CMAKE_INSTALL_PREFIX}/share/man")
ENDIF(NOT MANDIR)

IF(NOT SBINDIR)
	SET(SBINDIR "${CMAKE_INSTALL_PREFIX}/sbin")
ENDIF(NOT SBINDIR)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)

############################# OPTIONS SECTION #############################################

OPTION(DEBUG_MODE          "Enable debug output [default: ON]"                  ON)
OPTION(ENABLE_OPTIMIZATION "Enable optimization [default: OFF]"                 OFF)
OPTION(ENABLE_DKIM         "Enable dkim signatures [default: OFF]"              OFF)
OPTION(ENABLE_SPF          "Enable SPF checks [default: OFF]"                   OFF)
OPTION(WANT_SYSTEMD_UNITS  "Install systemd unit files on Linux [default: OFF]" OFF)

############################# INCLUDE SECTION #############################################

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCCompilerFlag)
INCLUDE(FindThreads)

FIND_PACKAGE(BISON)
FIND_PACKAGE(FLEX)

# Process required package by using FindPackage and calling for INCLUDE_DIRECTORIES and
# setting list of required libraries
# Usage:
# ProcessPackage(VAR [OPTIONAL] [ROOT path] [INCLUDE path]
#	[LIBRARY path] [INCLUDE_SUFFIXES path1 path2 ...] [LIB_SUFFIXES path1 path2 ...]
#	[MODULES module1 module2 ...])
# params:
# OPTIONAL - do not fail if a package has not been found
# ROOT - defines root directory for a package
# INCLUDE - name of the include file to check
# LIBRARY - name of the library to check 
# INCLUDE_SUFFIXES - list of include suffixes (relative to ROOT)
# LIB_SUFFIXES - list of library suffixes
# MODULES - modules to search using pkg_config
MACRO(ProcessPackage PKG_NAME)

	CMAKE_PARSE_ARGUMENTS(PKG "OPTIONAL" "ROOT;INCLUDE" 
		"LIBRARY;INCLUDE_SUFFIXES;LIB_SUFFIXES;MODULES" ${ARGN})

	IF(NOT PKG_LIBRARY)
		SET(PKG_LIBRARY "${PKG_NAME}")
	ENDIF()
	IF(NOT PKG_INCLUDE)
		SET(PKG_INCLUDE "${PKG_NAME}.h")
	ENDIF()

	IF(NOT PKG_ROOT AND PKG_MODULES)
		PKG_SEARCH_MODULE(${PKG_NAME} ${PKG_MODULES})
	ENDIF()
	
	IF(${PKG_NAME}_FOUND)
		MESSAGE(STATUS "Found package ${PKG_NAME} in pkg-config modules ${PKG_MODULES}")
		SET(WITH_${PKG_NAME} 1 CACHE INTERNAL "")
		IF(ENABLE_STATIC MATCHES "ON")
			SET(_XPREFIX "${PKG_NAME}_STATIC")
		ELSE(ENABLE_STATIC MATCHES "ON")
			SET(_XPREFIX "${PKG_NAME}")
		ENDIF(ENABLE_STATIC MATCHES "ON")
		FOREACH(_arg ${${_XPREFIX}_INCLUDE_DIRS})
			INCLUDE_DIRECTORIES("${_arg}")
			SET(${PKG_NAME}_INCLUDE "${_arg}")
		ENDFOREACH(_arg ${${_XPREFIX}_INCLUDE_DIRS})
		FOREACH(_arg ${${_XPREFIX}_LIBRARY_DIRS})
			LINK_DIRECTORIES("${_arg}")
			SET(${PKG_NAME}_LIBRARY "${_arg}")
		ENDFOREACH(_arg ${${_XPREFIX}_LIBRARY_DIRS})
		# Handle other CFLAGS and LDFLAGS
		FOREACH(_arg ${${_XPREFIX}_CFLAGS_OTHER})
			SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${_arg}")
		ENDFOREACH(_arg ${${_XPREFIX}_CFLAGS_OTHER})
		FOREACH(_arg ${${_XPREFIX}_LDFLAGS_OTHER})
			SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${_arg}")
		ENDFOREACH(_arg ${${_XPREFIX}_LDFLAGS_OTHER})
		LIST(APPEND RMILTER_REQUIRED_LIBRARIES "${${_XPREFIX}_LIBRARIES}")
		INCLUDE_DIRECTORIES(${${_XPREFIX}_INCLUDEDIR})
	ELSE()
		IF(NOT ${PKG_NAME}_GUESSED)
			# Try some more heuristic
			FIND_LIBRARY(_lib NAMES ${PKG_LIBRARY}
						HINTS "${PKG_ROOT}" "${RMILTER_SEARCH_PATH}"
						PATH_SUFFIXES "${PKG_LIB_SUFFIXES}" lib64 lib
						PATHS ${RMILTER_DEFAULT_LIBRARY_PATHS})
			IF(NOT _lib)
				IF(OPTIONAL)
					MESSAGE("Cannot find library ${PKG_LIBRARY} for package ${PKG_NAME}")
				ELSE()
					MESSAGE(FATAL_ERROR "Cannot find library ${PKG_LIBRARY} for package ${PKG_NAME}")
				ENDIF()
			ENDIF(NOT _lib)
			
			FIND_PATH(_incl "${PKG_INCLUDE}" 
							HINTS "${PKG_ROOT}" "${RMILTER_SEARCH_PATH}"
							PATH_SUFFIXES "${PKG_INCLUDE_SUFFIXES}" "include"
							PATHS 	${RMILTER_DEFAULT_INCLUDE_PATHS})
			IF(NOT _incl)
				IF(OPTIONAL)
					MESSAGE("Cannot find header ${PKG_INCLUDE} for package ${PKG_NAME}")
				ELSE()
					MESSAGE(FATAL_ERROR "Cannot find header ${PKG_INCLUDE} for package ${PKG_NAME}")
				ENDIF()
			ENDIF(NOT _incl)
			
			IF(_incl AND _lib)
				GET_FILENAME_COMPONENT(_lib_path "${_lib}" PATH)
				INCLUDE_DIRECTORIES("${_incl}")
				LINK_DIRECTORIES("${_lib_path}")
				LIST(APPEND RMILTER_REQUIRED_LIBRARIES ${_lib})
				SET(${PKG_NAME}_INCLUDE "${_incl}" CACHE INTERNAL "")
				SET(${PKG_NAME}_LIBRARY_PATH "${_lib_path}" CACHE INTERNAL "")
				SET(${PKG_NAME}_LIBRARY "${_lib}" CACHE INTERNAL "")
				SET(${PKG_NAME}_GUESSED 1 CACHE INTERNAL "")
				SET(WITH_${PKG_NAME} 1 CACHE INTERNAL "")
				MESSAGE(STATUS "Found package ${PKG_NAME} in '${_lib_path}' (${_lib}) and '${_incl}' (${PKG_INCLUDE}).")
			ENDIF()
		
		ELSE()
			MESSAGE(STATUS "Found package ${PKG_NAME} (cached)")
			INCLUDE_DIRECTORIES("${${PKG_NAME}_INCLUDE}")
			LINK_DIRECTORIES("${${PKG_NAME}_LIBRARY_PATH}")
			LIST(APPEND RMILTER_REQUIRED_LIBRARIES "${${PKG_NAME}_LIBRARY}")
		ENDIF()
	ENDIF(${PKG_NAME}_FOUND)

	UNSET(_lib CACHE)
	UNSET(_incl CACHE)
ENDMACRO(ProcessPackage name)

############################# OS SECTION #############################################

IF(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_BSD_SOURCE -DFREEBSD")
	MESSAGE(STATUS "Configuring for FreeBSD")
ENDIF(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_BSD_SOURCE -DDARWIN")
    SET(CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS "${CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS} -undefined dynamic_lookup")
MESSAGE(STATUS "Configuring for Darwin")

ENDIF()

IF(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -DLINUX")
    IF(BUILD_CPU_MODE STREQUAL "32")
    	SET(CMAKE_C_FLAGS  "-D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE ${CMAKE_C_FLAGS}")
    ENDIF(BUILD_CPU_MODE STREQUAL "32")
    LIST(APPEND RMILTER_REQUIRED_LIBRARIES resolv)
ENDIF()

IF(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
 	IF(NOT BUILD_CPU_MODE)
	 	SET (BUILD_CPU_MODE "32")
	ENDIF(NOT BUILD_CPU_MODE)
	
	IF("${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Xa -xregs=no%frameptr -xstrconst -xc99")
		SET(SUN_BUILD32 "-xtarget=generic")
		SET(SUN_BUILD64 "-xtarget=generic64")
		IF(ENABLE_OPTIMIZATION MATCHES "ON")
			SET(CMAKE_C_OPT_FLAGS "-fast -xdepend")
		ELSE(ENABLE_OPTIMIZATION MATCHES "ON")
			SET(CMAKE_C_OPT_FLAGS "-xO0")
		ENDIF(ENABLE_OPTIMIZATION MATCHES "ON")
	ELSE("${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
		set(SUN_BUILD32 "-m32")
		set(SUN_BUILD64 "-m64")		
	ENDIF("${CMAKE_C_COMPILER_ID}" MATCHES SunPro)

 	IF (BUILD_CPU_MODE STREQUAL "32")
       message (STATUS "Building 32-bit mode on Solaris")
       # If we are asked to build 32 bit mode
       	set(CMAKE_C_FLAGS  "${SUN_BUILD32} ${CMAKE_C_FLAGS}")
       	set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS} ${SUN_BUILD32}")
 	ELSE (BUILD_CPU_MODE STREQUAL "32")
       # solaris 64-bit mode
		message (STATUS "Building 64-bit mode on Solaris")
       	set(CMAKE_C_FLAGS  "${SUN_BUILD64} ${CMAKE_C_FLAGS}")
       	set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS} ${SUN_BUILD64}")
    ENDIF (BUILD_CPU_MODE STREQUAL "32")

 	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__EXTENSIONS__ -DSOLARIS -D_POSIX_SOURCE -D_POSIX_C_SOURCE=200112L")
    
	LIST(APPEND RMILTER_REQUIRED_LIBRARIES rt)
	LIST(APPEND RMILTER_REQUIRED_LIBRARIES dl)
	LIST(APPEND RMILTER_REQUIRED_LIBRARIES resolv)
 	LIST(APPEND RMILTER_REQUIRED_LIBRARIES nsl)
 	LIST(APPEND RMILTER_REQUIRED_LIBRARIES socket)
 	LIST(APPEND RMILTER_REQUIRED_LIBRARIES umem)
  	SET(CMAKE_VERBOSE_MAKEFILE ON)
  	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
  	SET(CMAKE_INSTALL_RPATH "${PREFIX}/lib")	
ENDIF()

############################# CONFIGURE SECTION #############################################

INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include" 
					"${CMAKE_BINARY_DIR}/include"
					"${CMAKE_BINARY_DIR}/" 
					"${CMAKE_SOURCE_DIR}/compat"
					"${CMAKE_SOURCE_DIR}/uthash")

BISON_TARGET(CfgParser src/cfg_file.y ${CMAKE_CURRENT_BINARY_DIR}/cfg_yacc.c)
FLEX_TARGET(CfgScanner src/cfg_file.l  ${CMAKE_CURRENT_BINARY_DIR}/cfg_lex.c)
ADD_FLEX_BISON_DEPENDENCY(CfgScanner CfgParser)

ProcessPackage(OPENSSL LIBRARY crypto INCLUDE err.h INCLUDE_SUFFIXES include/openssl
	ROOT ${OPENSSL_ROOT_DIR} MODULES openssl)
ProcessPackage(PCRE LIBRARY pcre INCLUDE pcre.h INCLUDE_SUFFIXES include/pcre 
	ROOT ${PCRE_ROOT_DIR} MODULES pcre libpcre pcre3 libpcre3)
ProcessPackage(LIBMILTER LIBRARY milter INCLUDE mfapi.h INCLUDE_SUFFIXES include/libmilter 
	ROOT ${LIBMILTER_ROOT_DIR} MODULES libmilter)

IF(ENABLE_DKIM MATCHES "ON")
    SET(WITH_DKIM 1)
    ProcessPackage(OPENDKIM LIBRARY opendkim INCLUDE dkim.h 
    	INCLUDE_SUFFIXES include/opendkim
    	LIB_SUFFIXES lib/opendkim lib64/opendkim
		ROOT ${OPENDKIM_ROOT_DIR} MODULES opendkim)
ENDIF()

IF(ENABLE_SPF MATCHES "ON")
    SET(WITH_SPF 1)
    ProcessPackage(LIBSPF2 LIBRARY spf2 INCLUDE spf.h
    	INCLUDE_SUFFIXES include/spf include/spf2 
    	LIB_SUFFIXES lib/libspf2 lib64/libspf2 lib/libspf lib64/libspf
		ROOT ${LIBSPF2_ROOT_DIR} MODULES libspf2)
ENDIF()

# Process with warn flags
SET(CMAKE_C_WARN_FLAGS "")
CHECK_C_COMPILER_FLAG(-Wall SUPPORT_WALL)
CHECK_C_COMPILER_FLAG(-W SUPPORT_W)
CHECK_C_COMPILER_FLAG(-Wpointer-arith SUPPORT_WPOINTER)
CHECK_C_COMPILER_FLAG(-Wno-unused-parameter SUPPORT_WPARAM)
CHECK_C_COMPILER_FLAG(-Wno-unused-function SUPPORT_WFUNCTION)
CHECK_C_COMPILER_FLAG(-Wunused-variable SUPPORT_WUNUSED_VAR)
CHECK_C_COMPILER_FLAG(-Wpointer-sign SUPPORT_WPOINTER_SIGN)
CHECK_C_COMPILER_FLAG(-Wsign-compare SUPPORT_WSIGN_COMPARE)
CHECK_C_COMPILER_FLAG(-Wstrict-prototypes SUPPORT_WSTRICT_PROTOTYPES)
IF(NOT "${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
	CHECK_C_COMPILER_FLAG("-std=c99" SUPPORT_STD_FLAG)
ENDIF(NOT "${CMAKE_C_COMPILER_ID}" MATCHES SunPro)
IF(SUPPORT_W)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -W")
ENDIF(SUPPORT_W)
IF(SUPPORT_WALL)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wall")
ENDIF(SUPPORT_WALL)
IF(SUPPORT_WPOINTER)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wpointer-arith")
ENDIF(SUPPORT_WPOINTER)
IF(SUPPORT_WPARAM)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wno-unused-parameter")
ENDIF(SUPPORT_WPARAM)
IF(SUPPORT_WFUNCTION)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wno-unused-function")
ENDIF(SUPPORT_WFUNCTION)
IF(SUPPORT_WUNUSED_VAR)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wno-unused-variable")
ENDIF(SUPPORT_WUNUSED_VAR)
IF(SUPPORT_WPOINTER_SIGN)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wno-pointer-sign")
ENDIF(SUPPORT_WPOINTER_SIGN)
IF(SUPPORT_WSIGN_COMPARE)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wno-sign-compare")
ENDIF(SUPPORT_WSIGN_COMPARE)
IF(SUPPORT_WSTRICT_PROTOTYPES)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -Wstrict-prototypes")
ENDIF(SUPPORT_WSTRICT_PROTOTYPES)
IF(SUPPORT_STD_FLAG)
	SET(CMAKE_C_WARN_FLAGS "${CMAKE_C_WARN_FLAGS} -std=c99")
ENDIF(SUPPORT_STD_FLAG)

# Optimization flags
IF(NOT CMAKE_C_OPT_FLAGS)
	IF(ENABLE_OPTIMIZATION MATCHES "ON")
		SET(CMAKE_C_OPT_FLAGS "-O3 -fstrict-aliasing")
	ELSE(ENABLE_OPTIMIZATION MATCHES "ON")
		SET(CMAKE_C_OPT_FLAGS "-O0 -fstrict-aliasing")
	ENDIF(ENABLE_OPTIMIZATION MATCHES "ON")
ENDIF(NOT CMAKE_C_OPT_FLAGS)

IF(DEBUG_MODE MATCHES "ON")
	SET(CMAKE_BUILD_TYPE "Debug")
ENDIF(DEBUG_MODE MATCHES "ON")

=== debian/changelog ===
rmilter (1.6.3) unstable; urgency=low

  * New release.

 -- Mikhail Gusarov <dottedmag@debian.org>  Sat, 18 Jul 2015 22:11:32 +0200

rmilter (1.6.2) unstable; urgency=low

  * Use systemd socket activation.
  * Bump Standards-Version to 3.9.6, no changes required

 -- Mikhail Gusarov <dottedmag@debian.org>  Sat, 21 Feb 2015 18:40:13 +0100

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: mail
 Priority: extra
 Maintainer: Mikhail Gusarov <dottedmag@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), cmake, libpcre3-dev, libssl-dev (>= 1.0), libopendkim-dev, libmilter-dev, libspf2-dev, bison, flex
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), cmake, libpcre3-dev, libssl-dev (>= 1.0), libopendkim-dev, libmilter-dev, libspf2-dev, bison, flex, dh-systemd
+Standards-Version: 3.9.6
 Homepage: https://github.com/vstakhov/rmilter
 Vcs-Git: git://github.com/vstakhov/rmilter.git
 Vcs-Browser: https://github.com/vstakhov/rmilter
 
 Package: rmilter
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libmilter1.0.1 (>= 8.14.4-6)
 Recommends: sendmail | postfix
 Description: Another sendmail milter for different mail checks
  rmilter is a standalone application that provides the following features:

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with systemd

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_SPF=ON \
		-DENABLE_DKIM=ON \
		-DMANDIR=/usr/share/man

override_dh_systemd_enable:
	dh_systemd_enable rmilter.socket

override_dh_systemd_start:
	dh_systemd_start --restart-after-upgrade --no-start

override_dh_installinit:
	dh_installinit -n
